# $Revision: 1.54 $, $Date: 2012/03/28 07:27:47 $
#
# TODO:
#   - think about moving modules to subpackages. At least, those with extra
#     dependencies.
#   - maybe there is no need to pack *.py (are *.pyc enough?)
#
# Conditional build:
%bcond_without	geoip		# without GeoIP support
%bcond_without	mysql		# without MySQL support
%bcond_without	ldap		# without LDAP support
%bcond_without	ffmpeg		# without ffmpeg support
#
Summary:	Fast, Flexible and Lightweight Web server
Summary(pl.UTF-8):	Cherokee - serwer WWW
Name:		cherokee
Version:	1.2.98
Release:	5
License:	GPL v2
Group:		Networking/Daemons
Source0:	http://www.cherokee-project.com/download/1.2/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	21b01e7d45c0e82ecc0c4257a9c27feb
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.upstart
Patch0:		%{name}-config.patch
Patch1:		%{name}-panic_path.patch
URL:		http://www.cherokee-project.com/
%{?with_geoip:BuildRequires:	GeoIP-devel}
BuildRequires:	autoconf
BuildRequires:	automake
%{?with_ffmpeg:BuildRequires:	ffmpeg-devel}
BuildRequires:	gettext-devel
BuildRequires:	libtool
%{?with_mysql:BuildRequires:	mysql-devel}
%{?with_ldap:BuildRequires:	openldap-devel}
BuildRequires:	openssl-devel
BuildRequires:	pam-devel
BuildRequires:	pcre-devel
BuildRequires:	php(fcgi)
BuildRequires:	pkgconfig
BuildRequires:	python-docutils
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.561
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	%{name}-libs = %{version}-%{release}
Requires:	rc-scripts >= 0.4.3.0
Suggests:	%{name}-admin = %{version}-%{release}
Suggests:	php(fcgi)
Provides:	group(cherokee)
Provides:	group(http)
Provides:	user(cherokee)
Provides:	webserver
Provides:	webserver(indexfile)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/cherokee
%define		_wwwhome	/home/services/%{name}
%define		_wwwroot	%{_wwwhome}/html

%description
Cherokee is a flexible, very fast, lightweight Web server. It is
implemented entirely in C, and has no dependencies beyond a standard C
library. It is embeddable and extensible with plug-ins. It supports
on-the-fly configuration by reading files or strings, TLS/SSL via
OpenSSL, virtual hosts, authentication, cache friendly features, PHP,
custom error management, and much more.

%description -l pl.UTF-8
Cherokee to elastyczny, bardzo szybki i lekki serwer WWW. Jest
zaimplementowany całkowicie w C i nie ma zależności poza standardową
biblioteką C. Jest osadzalny i rozbudowywalny poprzez wtyczki.
Obsługuje konfigurację w locie poprzez odczyt plików lub łańcuchów
znaków, TLS/SSL poprzez OpenSSL, hosty wirtualne, uwierzytelnianie,
opcje związane z pamięcią podręczną, PHP, własne zarządzanie błędami i
wiele więcej.

%package upstart
Summary:	Upstart job description for the Cherokee web server
Summary(pl.UTF-8):	Opis zadania Upstart dla serwera Cherokee
Group:		Daemons
Requires:	%{name} = %{version}-%{release}
Requires:	upstart >= 0.6

%description upstart
Upstart job description for the Cherokee web server.

%description upstart -l pl.UTF-8
Opis zadania Upstart dla serwera WWW Cherokee.

%package admin
Summary:	Cherokee web server administration interface
Summary(pl.UTF-8):	Interfejs administracyjny serwera WWW Cherokee
Group:		Networking/Daemons
Requires:	%{name} = %{version}-%{release}
Requires:	python
Requires:	python-modules

%description admin
Cherokee web server administration interface.

%description admin -l pl.UTF-8
Interfejs administracyjny serwera WWW Cherokee.

%package devel
Summary:	Header files for Cherokee web server
Summary(pl.UTF-8):	Pliki nagłówkowe dla serwera WWW Cherokee
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for Cherokee web server.

%description devel -l pl.UTF-8
Pliki nagłówkowe dla serwera WWW Cherokee.

%package libs
Summary:	Cherokee web server libraries
Summary(pl.UTF-8):	Biblioteki serwera WWW Cherokee
Group:		Libraries

%description libs
Cherokee web server libraries.

%description libs -l pl.UTF-8
Biblioteki serwera WWW Cherokee.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--with-php=/usr/bin/php.cgi \
	--disable-static \
	--enable-os-string="PLD Linux" \
	--sysconfdir=/etc \
	--with-wwwroot=%{_wwwroot} \
	--with-wwwuser=cherokee \
	--with-wwwgroup=http \
	%{!?with_geoip:--without-geoip} \
	%{!?with_mysql:--without-mysql} \
	%{!?with_ffmpeg:--without-ffmpeg} \
	%{!?with_ldap:--without-ldap}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{init,pam.d,sysconfig,rc.d/init.d},/var/log/%{name}}

%{__make} -j1 install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
install %{SOURCE3} $RPM_BUILD_ROOT/etc/init/%{name}.conf

# users don't need this
mv $RPM_BUILD_ROOT{%{_bindir},%{_sbindir}}/cherokee-panic

# modules dlopened by *.so
rm -f $RPM_BUILD_ROOT%{_libdir}/cherokee/lib*.la

# unify manual dir
rm -rf html
mv $RPM_BUILD_ROOT%{_docdir}/%{name} html

# provided via %doc
rm $RPM_BUILD_ROOT/etc/cherokee/cherokee.conf.perf_sample

# compile python modules, otherwise *.pyc may get generated on runtime
# and stay after package removal
%py_comp $RPM_BUILD_ROOT%{_datadir}/cherokee/admin/

# seems like this is not needed on Linux
rm $RPM_BUILD_ROOT%{_bindir}/cherokee-macos-askpass

mv $RPM_BUILD_ROOT%{_localedir}/{sv_SE,sv}
%find_lang %{name}


%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 161 cherokee
%groupadd -g 51 http
%useradd -u 161 -d %{_wwwhome} -c "Cherokee User" -g cherokee cherokee
%addusertogroup cherokee http

%post
/sbin/chkconfig --add %{name}
%service %{name} restart "Cherokee webserver"
exit 0

%preun
if [ "$1" = "0" ]; then
	%service %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
if [ "$1" = "0" ]; then
	%userremove cherokee
	%groupremove cherokee
	%groupremove http
fi

%post upstart
%upstart_post %{name}

%postun upstart
%upstart_postun %{name}

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog html performance.conf.sample
%dir %attr(750,root,root) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/cherokee.conf

%config(noreplace) %verify(not md5 mtime size) /etc/pam.d/cherokee
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/cherokee
%attr(754,root,root) /etc/rc.d/init.d/cherokee

%attr(755,root,root) %{_bindir}/CTK-run
%attr(755,root,root) %{_bindir}/cget
%attr(755,root,root) %{_bindir}/cherokee-tweak
%attr(755,root,root) %{_sbindir}/cherokee
%attr(755,root,root) %{_sbindir}/cherokee-panic
%attr(755,root,root) %{_sbindir}/cherokee-worker

%dir %{_libdir}/cherokee
%attr(755,root,root) %{_libdir}/cherokee/libplugin_admin.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_and.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_authlist.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_bind.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_cgi.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_combined.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_common.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_custom_error.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_custom.so
%{?with_mysql:%attr(755,root,root) %{_libdir}/cherokee/libplugin_dbslayer.so}
%attr(755,root,root) %{_libdir}/cherokee/libplugin_deflate.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_directory.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_dirlist.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_drop.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_empty_gif.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_error_nn.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_error_redir.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_evhost.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_exists.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_extensions.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_failover.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_fcgi.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_file.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_from.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_fullpath.so
%{?with_geoip:%attr(755,root,root) %{_libdir}/cherokee/libplugin_geoip.so}
%attr(755,root,root) %{_libdir}/cherokee/libplugin_gzip.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_header.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_htdigest.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_htpasswd.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_ip_hash.so
%{?with_ldap:%attr(755,root,root) %{_libdir}/cherokee/libplugin_ldap.so}
%attr(755,root,root) %{_libdir}/cherokee/libplugin_libssl.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_method.so
%{?with_mysql:%attr(755,root,root) %{_libdir}/cherokee/libplugin_mysql.so}
%attr(755,root,root) %{_libdir}/cherokee/libplugin_ncsa.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_not.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_or.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_pam.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_plain.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_post_report.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_post_track.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_proxy.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_redir.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_rehost.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_render_rrd.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_request.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_round_robin.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_rrd.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_scgi.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_secdownload.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_server_info.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_ssi.so
%if %{with ffmpeg}
%attr(755,root,root) %{_libdir}/cherokee/libplugin_streaming.so
%endif
%attr(755,root,root) %{_libdir}/cherokee/libplugin_target_ip.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_tls.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_url_arg.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_uwsgi.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_v_or.so
%attr(755,root,root) %{_libdir}/cherokee/libplugin_wildcard.so

%{_mandir}/man1/cget.1*
%{_mandir}/man1/cherokee.1*
%{_mandir}/man1/cherokee-tweak.1*
%{_mandir}/man1/cherokee-worker.1*

%dir %{_datadir}/cherokee
%{_datadir}/cherokee/deps
%{_datadir}/cherokee/icons
%{_datadir}/cherokee/themes

%dir %{_wwwhome}
%dir %{_wwwroot}
%config(missingok) %{_wwwroot}/*

%dir %attr(750,cherokee,logs) /var/log/%{name}

%dir %attr(771,root,cherokee) /var/lib/%{name}
%dir %attr(771,cherokee,cherokee) /var/lib/%{name}/graphs
%dir %attr(771,cherokee,cherokee) /var/lib/%{name}/graphs/images

%files upstart
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/init/%{name}.conf

%files admin -f %{name}.lang
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/cherokee-admin
%attr(755,root,root) %{_bindir}/cherokee-admin-launcher
%{_mandir}/man1/cherokee-admin.1*
%{_mandir}/man1/cherokee-admin-launcher.1*
%dir %{_datadir}/cherokee/admin
%{_datadir}/cherokee/admin/cherokee.conf.sample
%{_datadir}/cherokee/admin/performance.conf.sample
%{_datadir}/cherokee/admin/*.html
%attr(755,root,root) %{_datadir}/cherokee/admin/*.py
%{_datadir}/cherokee/admin/*.pyc
%{_datadir}/cherokee/admin/static
%dir %{_datadir}/cherokee/admin/CTK
%dir %{_datadir}/cherokee/admin/CTK/CTK
%{_datadir}/cherokee/admin/CTK/CTK/*.py
%{_datadir}/cherokee/admin/CTK/CTK/*.pyc
%{_datadir}/cherokee/admin/CTK/static
%dir %{_datadir}/cherokee/admin/plugins
%{_datadir}/cherokee/admin/plugins/*.py
%{_datadir}/cherokee/admin/plugins/*.pyc
%dir %{_datadir}/cherokee/admin/wizards
%{_datadir}/cherokee/admin/wizards/*.py
%{_datadir}/cherokee/admin/wizards/*.pyc
%dir %{_datadir}/cherokee/admin/market
%{_datadir}/cherokee/admin/market/*.py
%{_datadir}/cherokee/admin/market/*.pyc
%dir %{_datadir}/cherokee/admin/icons
%{_datadir}/cherokee/admin/icons/*.png
%{_datadir}/cherokee/admin/icons/*.svg

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcherokee-base.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcherokee-base.so.0
%attr(755,root,root) %{_libdir}/libcherokee-client.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcherokee-client.so.0
%attr(755,root,root) %{_libdir}/libcherokee-server.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcherokee-server.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/cherokee-config
%attr(755,root,root) %{_libdir}/libcherokee-base.so
%attr(755,root,root) %{_libdir}/libcherokee-client.so
%attr(755,root,root) %{_libdir}/libcherokee-server.so
%{_libdir}/libcherokee-base.la
%{_libdir}/libcherokee-client.la
%{_libdir}/libcherokee-server.la
%{_includedir}/cherokee
%{_pkgconfigdir}/cherokee.pc
%{_aclocaldir}/cherokee.m4
%{_mandir}/man1/cherokee-config.1*

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: cherokee.spec,v $
Revision 1.54  2012/03/28 07:27:47  arekm
- release 5

Revision 1.53  2011/09/25 10:40:53  glen
- update upstart deps

Revision 1.52  2011/07/24 15:53:49  arekm
- release 4

Revision 1.51  2011/06/27 19:22:03  arekm
- release 3

Revision 1.50  2011/06/22 07:18:42  jajcus
- P: webserver(indexfile) (required by mailman)
- Release: 2

Revision 1.49  2011/06/15 13:32:18  jajcus
- Version: 1.2.98

Revision 1.48  2011/03/31 18:11:07  arekm
- release 2

Revision 1.47  2011/02/15 14:35:09  jajcus
- 'ffmpeg' bcond fix (no 'streaming' plugin without ffmpeg)

Revision 1.46  2011/02/15 13:47:57  jajcus
- Version: 1.0.20

Revision 1.45  2010/11/30 19:01:57  jajcus
- Version: 1.0.10

Revision 1.44  2010/08/31 17:37:25  jajcus
- Verision: 1.0.8

Revision 1.43  2010/07/08 17:30:18  jajcus
- Release: 2
- libplugin_tls.so included

Revision 1.42  2010/07/08 06:39:15  jajcus
- Version: 1.0.5

Revision 1.41  2010/06/23 12:57:53  pawelz
- up to 1.0.4

Revision 1.40  2010/06/23 12:47:42  pawelz
- Updated deps for php-5.3: s/php-fcgi/php(fcgi)/

Revision 1.39  2010/06/16 09:56:02  jajcus
- Version: 1.0.2

Revision 1.38  2010/05/21 06:38:49  jajcus
- Version: 1.0.1

Revision 1.37  2010/05/15 23:23:31  sparky
- BR: gettext-devel

Revision 1.36  2010/05/12 07:10:40  jajcus
- -upstart subpackage
- Release: 2

Revision 1.35  2010/05/12 06:05:20  jajcus
- Version: 1.0.0 :)

Revision 1.34  2010/05/01 09:10:36  jajcus
- Version: 0.99.48
- pack compiled python modules

Revision 1.33  2010/04/12 19:24:05  arekm
- release 3

Revision 1.32  2010/04/09 09:43:28  jajcus
- patch to enable support for more WebDAV request method (needed by a reverse
  proxy to SVN)

Revision 1.31  2010/04/09 07:04:32  jajcus
- Release: 2

Revision 1.30  2010/04/09 06:58:31  jajcus
- force -j1 to make install

Revision 1.29  2010/04/08 08:31:36  jajcus
- Release: 1
- TODO updated (spawn-fcgi doesn't seem used by cherokee, except for the admin
  wizards for MoinMoin and RoR)

Revision 1.28  2010/04/08 06:39:38  jajcus
- locale: sv_SE -> sv
- package /var/lib/cherokee and the subdirectories

Revision 1.27  2010/04/07 13:16:14  jajcus
- admin subpackage separated

Revision 1.26  2010/04/07 13:00:32  jajcus
- mysql, ffmpeg and ldap bconds added

Revision 1.25  2010/04/07 12:31:26  jajcus
- Version: 0.99.44
- use find_lang to package localisation

Revision 1.24  2009/11/28 02:31:27  pawelz
- dropped spawn-fcgi (dropped upstream, but does it requires spawn-fcgi?)
- dropped gnutls (dropped upstream)
- BR: ffmpeg-devel, php-fcgi
- PHPCGI must be exported, not passwd as configure argument
- updated configure options
- updated %files:
  dropped 3 modules
  many new modules
  other small changes
- needs testing

Revision 1.23  2009/11/28 01:14:46  pawelz
- started upgrade to 0.99.29

Revision 1.22  2008/10/21 18:48:12  charles
- added -panic_path.patch

Revision 1.21  2008/10/21 15:49:20  qboosh
- no daemons should be required by development packages: separated -libs

Revision 1.20  2008/10/21 06:28:51  qboosh
- sorted BRs

Revision 1.19  2008/10/21 00:32:48  charles
- without geoip bcond

Revision 1.18  2008/10/21 00:22:38  charles
- updated to 0.9.4
- BR: GeoIP-devel, libtool, rpm-pythonprov
- updated %configure & %files

Revision 1.17  2008/05/26 13:48:04  patrys
- 0.7.0

Revision 1.16  2008-04-17 15:57:25  patrys
- 0.6.1
- use guardian as default daemon
- works
- TODO: package %{_libdir}/libcherokee*

Revision 1.15  2007-02-12 21:23:50  glen
- tabs in preamble

Revision 1.14  2007/02/12 00:48:41  baggins
- converted to UTF-8

Revision 1.13  2006/01/05 08:42:48  qboosh
- updated pl

Revision 1.12  2006/01/04 21:46:55  qboosh
- bcond header, strict internal dep

Revision 1.11  2005/12/31 16:25:09  glen
- fixed user removal and post script

Revision 1.10  2005/12/31 16:19:09  glen
- fix pam install (it needs /etc/pam.d to install file)

Revision 1.9  2005/12/31 16:18:34  glen
- secure config dirs, add logdir

Revision 1.8  2005/12/31 15:34:58  glen
- added user
- files fixes
- PHP support appears to be via php-cgi

Revision 1.7  2005/12/31 14:29:13  glen
- updated to 0.4.29
- this version supports PHP

Revision 1.6  2005/12/12 15:19:32  glen
- adapterized (sorted %verify flags)

Revision 1.5  2004/11/07 09:49:40  ankry
- Provides: webserver

Revision 1.4  2003/12/27 14:44:29  qboosh
- deal with shared lib and modules; BR: pam-devel,pkgconfig,zlib-devel

Revision 1.3  2003/12/27 13:11:56  qboosh
- pl, some cleanups

Revision 1.2  2003/12/27 05:22:44  aredridel
- add gnome-vfs2 and fcgi

Revision 1.1  2003/12/27 05:07:17  aredridel
- added
